KDE 4.7 PyKDE API Reference

- KDE's Python API

# KUriFilter Class Reference

`from PyKDE4.kio import *`

## Detailed Description

KUriFilter applies a number of filters to a URI and returns a filtered version if any filter matches. A simple example is "kde.org" to "http://www.kde.org", which is commonplace in web browsers.

The filters are implemented as plugins in KUriFilterPlugin subclasses.

KUriFilter is a singleton object: obtain the instance by calling KUriFilter.self() and use the public member functions to perform the filtering.

Example

To simply filter a given string:

     QString url("kde.org");
     bool filtered = KUriFilter.self()->filteredUri( url );

You can alternatively use a KUrl:

     KUrl url("kde.org");
     bool filtered = KUriFilter.self()->filterUri( url );

If you have a constant string or a constant URL, simply invoke the corresponding function to obtain the filtered string or URL instead of a boolean flag:

     QString filteredText = KUriFilter.self()->filteredUri( "kde.org" );

All of the above examples should result in "kde.org" being filtered into "http://kde.org".

You can also restrict the filters to be used by supplying the name of the filters you want to use. By defualt all available filters are used.

To use specific filters, add the names of the filters you want to use to a QStringList and invoke the appropriate filtering function.

The examples below show the use of specific filters. KDE ships with the following filter plugins by default:

kshorturifilter: This is used for filtering potentially valid url inputs such as "kde.org" Additionally it filters shell variables and shortcuts such as $HOME and ~ as well as man and info page shortcuts, # and ## respectively.

kuriikwsfilter: This is used for filtering normal input text into a web search url using the configured fallback search engine selected by the user.

kurisearchfilter: This is used for filtering KDE webshortcuts. For example "gg:KDE" will be converted to a url for searching the work "KDE" using the Google search engine.

localdomainfilter: This is used for doing a DNS lookup to determine whether the input is a valid local address.

fixuphosturifilter: This is used to append "www." to the host name of a pre filtered http url if the original url cannot be resolved.

     QString text ("kde.org");
     bool filtered = KUriFilter.self()->filterUri(text, QLatin1String("kshorturifilter"));

The above code should result in "kde.org" being filtered into "http://kde.org".

     QStringList list;
     list << QLatin1String("kshorturifilter") << QLatin1String("localdomainfilter");
     bool filtered = KUriFilter.self()->filterUri( text, list );

Additionally if you only want to do search related filtering, you can use the search specific function, filterSearchUri, that is available in KDE 4.5 and higher. For example, to search for a given input on the web you can do the following:

KUriFilterData filterData ("foo"); bool filtered = KUriFilter.self()->filterSearchUri(filterData, KUriFilterData.NormalTextFilter);

KUriFilter converts all filtering requests to use KUriFilterData internally. The use of this bi-directional class allows you to send specific instructions to the filter plugins as well as receive detailed information about the filtered request from them. See the documentation of KUriFilterData class for more examples and details.

All functions in this class are thread safe and reentrant.

Filters the given input into a valid url whenever possible.

## Enumerations
SearchFilterType | { NormalTextFilter, WebShortcutFilter }
## Methods
| __init__ (self)
| __init__ (self, KUriFilter other)
bool | filterSearchUri (self, KUriFilterData data)
bool | filterSearchUri (self, KUriFilterData data, KUriFilter.SearchFilterTypes types)
bool | filterUri (self, KUriFilterData data, QStringList filters=QStringList())
bool | filterUri (self, KUrl uri, QStringList filters=QStringList())
bool | filterUri (self, QString uri, QStringList filters=QStringList())
KUrl | filteredUri (self, KUrl uri, QStringList filters=QStringList())
QString | filteredUri (self, QString uri, QStringList filters=QStringList())
| loadPlugins (self)
QStringList | pluginNames (self)
## Static Methods
KUriFilter | self ()

## Method Documentation

__init__ | ( |  | self ) |

Constructor.

Creates a KUriFilter object and calls loadPlugins to load all available URI filter plugins.

__init__ | ( | self, |
|  | KUriFilter | other
| ) |  |  |

bool filterSearchUri | ( | self, |
|  | KUriFilterData | data
| ) |  |  |

Filter data using the criteria specified by types.

The search filter type can be individual value of SearchFilterTypes or a combination of those types using the bitwise OR operator.

You can also use the flags from KUriFilterData.SearchFilterOption to alter the filtering mechanisms of the search filter providers.

Parameters:

  | data | object that contains the URI to be filtered.
  | types | the search filters used to filter the request.

Returns:
  true if the specified data was successfully filtered.

See also:
  KUriFilterData.setSearchFilteringOptions

Since:
  4.6

bool filterSearchUri | ( | self, |
|  | KUriFilterData | data,
|  | KUriFilter.SearchFilterTypes | types
| ) |  |  |

Filter data using the criteria specified by types.

The search filter type can be individual value of SearchFilterTypes or a combination of those types using the bitwise OR operator.

You can also use the flags from KUriFilterData.SearchFilterOption to alter the filtering mechanisms of the search filter providers.

Parameters:

  | data | object that contains the URI to be filtered.
  | types | the search filters used to filter the request.

Returns:
  true if the specified data was successfully filtered.

See also:
  KUriFilterData.setSearchFilteringOptions

Since:
  4.6

bool filterUri | ( | self, |
|  | KUriFilterData | data,
|  | QStringList | filters=QStringList()
| ) |  |  |

Filters a string representing a URI.

The given URL is filtered based on the specified list of filters. If the list is empty all available filters would be used.

Parameters:

  | uri | The URI to filter.
  | filters | specify the list of filters to be used.

Returns:
  a boolean indicating whether the URI has been changed

bool filterUri | ( | self, |
|  | KUrl | uri,
|  | QStringList | filters=QStringList()
| ) |  |  |

Filters a string representing a URI.

The given URL is filtered based on the specified list of filters. If the list is empty all available filters would be used.

Parameters:

  | uri | The URI to filter.
  | filters | specify the list of filters to be used.

Returns:
  a boolean indicating whether the URI has been changed

bool filterUri | ( | self, |
|  | QString | uri,
|  | QStringList | filters=QStringList()
| ) |  |  |

Filters a string representing a URI.

The given URL is filtered based on the specified list of filters. If the list is empty all available filters would be used.

Parameters:

  | uri | The URI to filter.
  | filters | specify the list of filters to be used.

Returns:
  a boolean indicating whether the URI has been changed

KUrl filteredUri | ( | self, |
|  | KUrl | uri,
|  | QStringList | filters=QStringList()
| ) |  |  |

Return a filtered string representation of a URI.

The given URL is filtered based on the specified list of filters. If the list is empty all available filters would be used.

Parameters:

  | uri | the URI to filter.
  | filters | specify the list of filters to be used.

Returns:
  the filtered URI or null if it cannot be filtered

QString filteredUri | ( | self, |
|  | QString | uri,
|  | QStringList | filters=QStringList()
| ) |  |  |

Return a filtered string representation of a URI.

The given URL is filtered based on the specified list of filters. If the list is empty all available filters would be used.

Parameters:

  | uri | the URI to filter.
  | filters | specify the list of filters to be used.

Returns:
  the filtered URI or null if it cannot be filtered

loadPlugins | ( |  | self ) |

Loads all allowed plugins.

This function only loads URI filter plugins that have not been disabled.

QStringList pluginNames | ( |  | self ) |

Return a list of the names of all loaded plugins.

Returns:
  a QStringList of plugin names

## Static Method Documentation

KUriFilter self | ( |  | ) |

Returns an instance of KUriFilter.

## Enumeration Documentation

SearchFilterType

This enum describes the types of search plugin filters available.

- NormalTextFilter The plugin used to filter normal text, e.g. "some term to search".
- WebShortcutFilter The plugin used to filter web shortcuts, e.g. gg:KDE.

Enumerator:

  NormalTextFilter = 0x01 |
  WebShortcutFilter = 0x02 |